/*#######################################################################################
Copyright (C) 2004 Ulrich Radig

Bei Fragen und Verbesserungen wendet euch per EMail an

mail@ulrichradig.de

oder im Forum meiner Web Page : www.ulrichradig.de


Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
GNU General Public License, wie von der Free Software Foundation verffentlicht, 
weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
(nach Ihrer Option) jeder spteren Version. 

Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
Programm erhalten haben. 
Falls nicht, schreiben Sie an die Free Software Foundation, 
Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
#######################################################################################*/

#include <lpc213x.h>
#include <stdlib.h>
#include <string.h>

#include "config.h"
#include "uart.h"
#include "printf_P.h"
#include "viclowlevel.h"
#include "enc28j60.h"
#include "typedefs.h"
#include "clock-arch.h"
//#include "telnetd.h"

#include "uip.h"
#include "uip_arp.h" 

#define BUF ((struct uip_eth_hdr *)&uip_buf[0])
#define BUFFER_SIZE 1500

void SystemInit(void);

U32 timer_value, periodic_timer_value;

/*void __attribute__ ((interrupt("IRQ"))) eint0(void) 
{ 
	printf("INT\n\r");         
    EXTINT = 1;
    VICVectAddr = 0; // Interrupt in VIC lschen
}*/

void SystemInit(void)
{
	// --- enable and connect the PLL (Phase Locked Loop) ---
	// a. set multiplier and divider
	PLLCFG = MSEL | (1<<PSEL1) | (0<<PSEL0);
	// b. enable PLL
	PLLCON = (1<<PLLE);
	// c. feed sequence
	PLLFEED = PLL_FEED1;
	PLLFEED = PLL_FEED2;
	// d. wait for PLL lock (PLOCK bit is set if locked)
	while (!(PLLSTAT & (1<<PLOCK)));
	// e. connect (and enable) PLL
	PLLCON = (1<<PLLE) | (1<<PLLC);
	// f. feed sequence
	PLLFEED = PLL_FEED1;
	PLLFEED = PLL_FEED2;
	
	// --- setup and enable the MAM (Memory Accelerator Module) ---
	// a. start change by turning of the MAM (redundant)
	MAMCR = 0;	
	// b. set MAM-Fetch cycle to 3 cclk as recommended for >40MHz
	MAMTIM = MAM_FETCH;
	// c. enable MAM 
	MAMCR = MAM_MODE;
	
	// --- set VPB speed ---
	VPBDIV = VPBDIV_VAL;
	
	// --- map INT-vector ---
	#if defined(RAM_RUN)
	  MEMMAP = MEMMAP_USER_RAM_MODE;
	#elif defined(ROM_RUN)
	  MEMMAP = MEMMAP_USER_FLASH_MODE;
	#else
	#error RUN_MODE not defined!
	#endif
}

/* *** MAIN ************************************************************* */
 
int main(void)
{
    U32 a,i;
	SystemInit();
    uart0Init(B9600, UART_8N1, UART_FIFO_8); // setup the UART
    print_f("\n\r*** START ***\n\r");

    uip_ipaddr_t ipaddr;
    
    //set Mac Addr.
    //(0xc0,0xa8,0x00,0x40,0x03,0x11); 
    uip_ethaddr.addr[0] = 0xc0;
    uip_ethaddr.addr[1] = 0xa8;
    uip_ethaddr.addr[2] = 0x00;
    uip_ethaddr.addr[3] = 0x40;
    uip_ethaddr.addr[4] = 0x03;
    uip_ethaddr.addr[5] = 0x11;

 	/*ENC Initialisieren*/
    for(a=0;a<1000000;a++);
    for(a=0;a<1000000;a++);
	enc28j60Init();
   	nicSetMacAddress(uip_ethaddr.addr);
	//enc28j60PhyWrite(0x14,0x0AA0); //0420 0AA0

    uip_init();
  
    uip_ipaddr(ipaddr, 192,168,0,99);
    uip_sethostaddr(ipaddr);
    uip_ipaddr(ipaddr, 192,168,0,98);
    uip_setdraddr(ipaddr);
    uip_ipaddr(ipaddr, 255,255,255,0);
    uip_setnetmask(ipaddr);	   

    uip_arp_init();
	//telnetd_init();
	httpd_init();
	enc28j60PhyWrite(0x14,0x0AA0); //0420 0AA0

    IODIR0 |= P0_23;
    IOPIN0 |= P0_23;
    
    PINSEL1 |= (1<<0);
 
    VICIntEnClear = 0xFFFFFFFF;
    VICIntSelect = 0x00000000; 
    
    init_timer();
    timer_value = SetDelay10ms(10000);
    periodic_timer_value    = SetDelay10ms(2);
    //VICVectAddr1 = (unsigned long)eint0;   // set interrupt vector in 0
	//VICVectCntl1 = (1<<5) | 14;             // use it for EXTINT0 Interrupt:
	//VICIntEnable |= (1<<14);                 // Enable EXTINT0 Interrupt 
   
    enableIRQ(); 

 
  while(1) {
 //   uip_len = tapdev_read();
//printf("%X\n\r",timer_counter);
  uip_len = enc28j60PacketReceive(BUFFER_SIZE, uip_buf);
     if(uip_len > 0) {
      if(BUF->type == htons(UIP_ETHTYPE_IP)) {
	uip_arp_ipin();
	uip_input();
	/* If the above function invocation resulted in data that
	   should be sent out on the network, the global variable
	   uip_len is set to a value > 0. */
	if(uip_len > 0) {
	  uip_arp_out();
	  enc28j60PacketSend(uip_len, uip_buf);
	  //tapdev_send();
	}
      } else if(BUF->type == htons(UIP_ETHTYPE_ARP)) {
	uip_arp_arpin();
	/* If the above function invocation resulted in data that
	   should be sent out on the network, the global variable
	   uip_len is set to a value > 0. */
	if(uip_len > 0) {
	  //tapdev_send();
	  enc28j60PacketSend(uip_len, uip_buf);
	}
      }

    } 
	else if(CheckDelay10ms(periodic_timer_value)) 
	{
		//timer_reset(&periodic_timer);
		// printf("###\n\r");

		periodic_timer_value = SetDelay10ms(50);
		IOPIN0 ^= P0_23;
		for(i = 0; i < UIP_CONNS; i++) {
			uip_periodic(i);
			/* If the above function invocation resulted in data that
			should be sent out on the network, the global variable
			uip_len is set to a value > 0. */
			if(uip_len > 0) {
				uip_arp_out();
				enc28j60PacketSend(uip_len, uip_buf);
				//tapdev_send();
			}
		}

#if UIP_UDP
      for(i = 0; i < UIP_UDP_CONNS; i++) {
	uip_udp_periodic(i);
	/* If the above function invocation resulted in data that
	   should be sent out on the network, the global variable
	   uip_len is set to a value > 0. */
	if(uip_len > 0) {
	  uip_arp_out();
	  enc28j60PacketSend(uip_len, uip_buf);
	  //tapdev_send();
	}
      }
#endif /* UIP_UDP */
      
      /* Call the ARP timer function every 10 seconds. */
      if(CheckDelay10ms(timer_value)) 
	  {
	    timer_value = SetDelay10ms(10000);
	    uip_arp_timer();

      }
    }
  }



/*
while(1)
	{
    //    for(a=0;a<100000;a++);
        IOPIN0 ^= P0_23;

    // look for a packet

    uip_len = enc28j60PacketReceive(BUFFER_SIZE, uip_buf);
    if(uip_len == 0)
    {
      // if timed out, call periodic function for each connection   
        for(i = 0; i < UIP_CONNS; i++)
        {
          uip_periodic(i);	
          // transmit a packet, if one is ready
          if(uip_len > 0)
          {
            uip_arp_out();
            enc28j60PacketSend(uip_len, uip_buf);
          }
        }
    }
    else  // packet received
    {
      // process an IP packet
      if(BUF->type == htons(UIP_ETHTYPE_IP))
      {
        // add the source to the ARP cache
        // also correctly set the ethernet packet length before processing
        uip_arp_ipin();
        uip_input();
        // transmit a packet, if one is ready
        if(uip_len > 0)
        {
          uip_arp_out();
          enc28j60PacketSend(uip_len, uip_buf);
        }
      }
      // process an ARP packet
      else if(BUF->type == htons(UIP_ETHTYPE_ARP))
      {
        uip_arp_arpin();
        // transmit a packet, if one is ready
        if(uip_len > 0)
         { uip_arp_out();
           enc28j60PacketSend(uip_len, uip_buf);
		 } 
      }
    }
  }  

*/
return(0);
}




