/*#######################################################################################
Copyright (C) 2004 Ulrich Radig

Bei Fragen und Verbesserungen wendet euch per EMail an

mail@ulrichradig.de

oder im Forum meiner Web Page : www.ulrichradig.de


Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
GNU General Public License, wie von der Free Software Foundation verffentlicht, 
weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
(nach Ihrer Option) jeder spteren Version. 

Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
Programm erhalten haben. 
Falls nicht, schreiben Sie an die Free Software Foundation, 
Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
#######################################################################################*/

#include <lpc213x.h>
#include <stdlib.h>
#include <string.h>

#include "config.h"
#include "uart.h"
#include "printf_P.h"
#include "viclowlevel.h"
#include "enc28j60.h"
#include "stack.h"
#include "typedefs.h"

#define BUFFER_SIZE 1518
U08 buffer[BUFFER_SIZE];

void __attribute__ ((interrupt("IRQ"))) eint0(void) 
{ 
	printf("INT\n\r");
	//Pointer auf Ethernet_Header
	struct Ethernet_Header *ethernet;
	ethernet = (struct Ethernet_Header *)&buffer[ETHER_OFFSET];
	//Pointer auf IP_Header
	struct IP_Header *ip;
	ip = (struct IP_Header *)&buffer[IP_OFFSET];
    
    U16 packet_lenght;
      
    packet_lenght = enc28j60PacketReceive(BUFFER_SIZE, buffer);
		/*Wenn ein Packet angekommen ist, ist packet_lenght =! 0*/
            packet_lenght = packet_lenght-4;
            
            if(Ethernet_ARP_Datagramm)
                {
                //Erzeugt ein ARP Reply Packet
                ARP_Reply(buffer,&packet_lenght);
                }
                
            if(Ethernet_IP_Datagramm && MyIP)
                {
                //Ist protokoll Byte = 1 dann ist es ein ICMP Packet
                if(IP_ICMP_Packet)
                    {
                    //Erzeugt ein ICMP Reply Packet (PING Echo)
                    ICMP_Reply(buffer,&packet_lenght);
                    }
                }
         
    EXTINT = 1;
    VICVectAddr = 0; 
}

void SystemInit(void)
{
	// --- enable and connect the PLL (Phase Locked Loop) ---
	// a. set multiplier and divider
	PLLCFG = MSEL | (1<<PSEL1) | (0<<PSEL0);
	// b. enable PLL
	PLLCON = (1<<PLLE);
	// c. feed sequence
	PLLFEED = PLL_FEED1;
	PLLFEED = PLL_FEED2;
	// d. wait for PLL lock (PLOCK bit is set if locked)
	while (!(PLLSTAT & (1<<PLOCK)));
	// e. connect (and enable) PLL
	PLLCON = (1<<PLLE) | (1<<PLLC);
	// f. feed sequence
	PLLFEED = PLL_FEED1;
	PLLFEED = PLL_FEED2;
	
	// --- setup and enable the MAM (Memory Accelerator Module) ---
	// a. start change by turning of the MAM (redundant)
	MAMCR = 0;	
	// b. set MAM-Fetch cycle to 3 cclk as recommended for >40MHz
	MAMTIM = MAM_FETCH;
	// c. enable MAM 
	MAMCR = MAM_MODE;
	
	// --- set VPB speed ---
	VPBDIV = VPBDIV_VAL;
	
	// --- map INT-vector ---
	#if defined(RAM_RUN)
	  MEMMAP = MEMMAP_USER_RAM_MODE;
	#elif defined(ROM_RUN)
	  MEMMAP = MEMMAP_USER_FLASH_MODE;
	#else
	#error RUN_MODE not defined!
	#endif
}

/* *** MAIN ************************************************************* */
 
int main(void)
{  
    myip[0] = 192;
    myip[1] = 168;
    myip[2] = 0;
    myip[3] = 99;
    
    mymac[0] = 0x00;
    mymac[1] = 0x20;
    mymac[2] = 0x18;
    mymac[3] = 0xb1;
    mymac[4] = 0x15;
    mymac[5] = 0x5f;
    
    /*
	//Pointer auf Ethernet_Header
	struct Ethernet_Header *ethernet;
	ethernet = (struct Ethernet_Header *)&buffer[ETHER_OFFSET];
	//Pointer auf IP_Header
	struct IP_Header *ip;
	ip = (struct IP_Header *)&buffer[IP_OFFSET];
    
    U16 packet_lenght;
    */
    
    U32 a;
	SystemInit();
    uart0Init(B9600, UART_8N1, UART_FIFO_8); // setup the UART
    
    //void (*start)(void);
    //start= (void(*)(void))main;  
    //(*start)();
 

	printf("\n\r*** START ***\n\r");	

    IODIR0 |= P0_23;
    IOPIN0 |= P0_23;
    
    PINSEL1 |= (1<<0);
    VICIntEnClear = 0xFFFFFFFF;
    VICIntSelect = 0x00000000; 
    
    VICVectAddr0 = (unsigned long)eint0;   // set interrupt vector in 0
	VICVectCntl0 = (1<<5) | 14;             // use it for EXTINT0 Interrupt:
	VICIntEnable = (1<<14);                 // Enable EXTINT0 Interrupt 

 	/*ENC Initialisieren*/
    for(a=0;a<1000000;a++);
    for(a=0;a<1000000;a++);
	enc28j60Init();
   
   	nicSetMacAddress(mymac);
   
    enableIRQ(); 
	
	enc28j60PhyWrite(0x14,0x0AA0); //0420 0AA0
 
	while(1)
		{
        for(a=0;a<1000000;a++);
        IOPIN0 ^= P0_23; 
        }
return(0);
}

